package ice.zxing;

import java.io.UnsupportedEncodingException; 
import android.content.Intent;
import android.util.Log;
import android.graphics.Bitmap;
import android.graphics.Color;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.IOnActivityResult;
import anywheresoftware.b4a.BA.DependsOn;
//import anywheresoftware.b4a.keywords.constants.Colors;   - this is working

//import com.google.zxing.client.android.*;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;

@ShortName("JhsIceZxing1")
@Version(1.0F)
@Author("Johan/IceFairy333")
@Events(values={"result(atype as String,Values as String)","noScan"})
//@Events(values={"result(atype as String,Values as String)"})
@ActivityObject
@Permissions(values={"android.permission.CAMERA","android.permission.WRITE_EXTERNAL_STORAGE","android.hardware.camera","android.hardware.camera.autofocus","android.permission.VIBRATE","android.permission.FLASHLIGHT"})

public class b4aZXingLib {
	@Hide
	public static BA myba;
	private IOnActivityResult ion;
        //these two public static variables will be available to be set in B4A once the library has been Dim'ed

        /**
        *Specify if it should be portrait or landscape mode
        *Example:<code> 
        *zx.isportrait = True
        </code>
        */
        public static boolean isportrait = true;

        /**
        *Specify if the front facing or rear facing camera should be used
        *Example:<code> 
        *zx.useFrontCam = False
        </code>
        */
        public static boolean useFrontCam = false;

        /**
        *Specify the color of the laser
        *Example:<code> 
        *zx.theLaserColor = Colors.Red
        </code>
        */
        public static int theLaserColor = Color.argb(255, 255, 0, 0);             //added by johan schoeman

        /**
        *Specify the color of the mask around the view finder rectangle
        *Example:<code>
        *zx.theMaskColor = Colors.ARGB(95, 0, 0, 255)
        </code>
        */
        public static int theMaskColor = Color.argb(95, 0, 0, 255);               //added by johan schoeman

        /**
        *Specify the color of the outer frame of the view finder rectangle
        *Example:<code>
        *zx.theFrameColor = Colors.Black
        </code>
        */
        public static int theFrameColor = Color.argb(255, 0, 255, 0);             //added by johan schoeman

        /**
        *Specify the color of the mask around the view finder rectangle after a successful scan
        *Example:<code>
        *zx.theResultColor = Colors.Black
        </code>
        */
        public static int theResultColor = Color.argb(255, 255, 255, 0);          //added by johan schoeman

        /**
        *Specify the color of the possible result points being displayed during a scan
        *Example:<code>
        *zx.theResultPointColor = Colors.Green
        </code>  
        */
        public static int theResultPointColor = Color.argb(255, 255, 0, 255);     //added by johan schoeman 

        /**
        *Scale factor for the width of the view finder rectangle
        *The factor ranges from 0 to 1 (for a width &lt; 240 a default of 240 pixels will be applied)
        *Example:<code>
        *zx.theViewFinderXfactor = 0.5
        </code>
        */
        public static double theViewFinderXfactor = 0.5;                          //added by johan schoeman  
 
        /**
        *Scale factor for the height of the view finder rectangle
        *The factor ranges from 0 to 1 (for a height &lt; 240 a default of 240 pixels will be applied)
        *Example:<code>
        *zx.theViewFinderYfactor = 0.5
        </code>
        */
        public static double theViewFinderYfactor = 0.5;                          //added by johan schoeman

        /**
        *Specify the top prompt message
        *Example:<code>
        *zx.theTopPromptMessage = "Hallo"
        </code>
        */
        public static String theTopPromptMessage = "";                            //added by johan schoeman 

        /**
        *Specify the bottom prompt message
        *Example:<code>
        *zx.theBottomPromptMessage = "B4A"
        </code>
        */
        public static String theBottomPromptMessage = "";                         //added by johan schoeman

        /**
        *Specify the text size of the top prompt message
        *Example:<code>
        *zx.theTopPromptTextSize = 5%y
        </code>
        */
        public static int theTopPromptTextSize = 25;                              //added by johan schoeman

        /**
        *Specify the text size of the bottom prompt message
        *Example:<code>
        *zx.theBottomPromptTextSize = 5%y
        </code>
        */
        public static int theBottomPromptTextSize = 25;                           //added by johan schoeman

        /**
        *Specify the distance of the top prompt message from the top
        *Example:<code>
        *zx.topPromptDistanceFromTop = 1%x
        </code>
        */
        public static int topPromptDistanceFromTop = 25;                          //added by johan schoeman

        /**
        *Specify the distance of the bottom prompt message from the bottom
        *Example:<code>
        *zx.bottomPromptDistanceFromBottom = 1%x
        </code>
        */
        public static int bottomPromptDistanceFromBottom = 25;                    //added by johan schoeman

        /**
        *Specify the color of the top prompt message
        *Example:<code>
        *zx.topPromptColor = Colors.Magenta
        </code>
        */
        public static int topPromptColor = Color.argb(255, 0, 0, 0);              //added by johan schoeman

        /**
        *Specify the color of the bottom prompt message
        *Example:<code>
        *zx.bottomPromptColor = Colors.Yellow
        </code>
        */
        public static int bottomPromptColor = Color.argb(255, 0, 0, 0);           //added by johan schoeman

        /**
        *Specify the timeout duration - we need to get a successful scan before this else time out
        *Example:<code>
        *zx.timeoutDuration = 15
        </code>
        *Set this value to for eg 2000000000 for and "indefinate" timeout (2 000 000 000 = 63 years+)
        */
        public static int timeoutDuration = 15;                                   //added by johan schoeman

        /**
        *Specify the bitmap that should be loaded into the mask
        *Example:<code> 
        *Dim bm As Bitmap
        *bm.Initialize(File.DirAssets,"B4A.png")
        *zx.theBitMap = bm 
        </code>
        */
        public static Bitmap theBitMap = null;                                    //added by johan schoeman

        @Hide
        public static int theBitMapLeft = 0;                                      //added by johan schoeman
        @Hide
        public static int theBitMapTop = 0;                                       //added by johan schoeman
        @Hide
        public static int theBitMapWidth = 0;                                     //added by johan schoeman
        @Hide
        public static int theBitMapHeight = 0;                                    //added by johan schoeman
        
        //added by johan schoeman for appearance purposes when typing for eg "zx." in the B4A project. One line of code in B4A and not four as before
        /**
        *Specify the left, top, width, and height of the bitmap that will be placed on the mask
        *Example:<code> 
        *zx.theBitmapPosition(40%x,10%y,20%x,20%x)
        </code> 
        */
        public static void theBitmapPosition(int left, int top, int width, int height){ 
          theBitMapLeft = left;
          theBitMapTop = top;
          theBitMapWidth = width;
          theBitMapHeight = height;  
        }

        /**
        *Specify if the device should vibrate upon a successful scan
        *The default value is False
        *It will vibrate for 400ms
        *
        *Example:<code> 
        *zx.mustVibrate = True
        *
        </code>
        */
        public static boolean mustVibrate = false;                                //added by johan schoeman

        /**
        *Specify if the device should make a beep sound upon a successful scan
        *The default value is False
        *The beep sound will be ToneGenerator.TONE_CDMA_ABBR_ALERT
        *
        *Example:<code> 
        *zx.mustBeep = True
        *
        </code>
        */
        public static boolean mustBeep = false;                                   //added by johan schoeman
 


	@Hide
	public static String en;

        /**
        *Start the scan 
        *Example:<code> 
        *Dim zx As JhsIceZxing1  '(declare this in Sub Globals)
        *Dim bm As Bitmap        '(declare this in Sub Globals)
        *
        *Sub Button1_Click
        *  zx.isportrait = True
        *  zx.useFrontCam = False
        *
        *  'set the timeoutDuration to a very high value (such as 2000000000) if you dont want it to time out 2000000000 = 63 years
        *  zx.timeoutDuration = 30
        *
        *  'change these factors between 0 and 1 to change the size of the viewfinder rectangle
        *  'the library will limit the minimum size to 240 x 240 pixels and the maximum to (screen width) x (screen height) pixels
        *  zx.theViewFinderXfactor = 0.7
        *  zx.theViewFinderYfactor = 0.5
        *  zx.theFrameColor = Colors.Blue
        *  zx.theLaserColor = Colors.Yellow
        *  zx.theMaskColor = Colors.argb(95, 0, 0, 255)
        *  zx.theResultColor = Colors.Green
        *  zx.theResultPointColor = Colors.Red
        *
        *  'set the prompt messages
        *  zx.theTopPromptMessage = "This was done......"
        *  zx.theTopPromptTextSize = 5%y 'text size
        *  zx.topPromptColor = Colors.Red
        *  zx.topPromptDistanceFromTop = 1%y 'pixel distance from top
        *  
        *  zx.theBottomPromptMessage = "Just for fun......"
        *  zx.theBottomPromptTextSize = 5%y  'text size
        *  zx.bottomPromptColor = Colors.Blue
        *  zx.bottomPromptDistanceFromBottom = 5%y  'pixel distance from top
        *  'add a bitmap
        *  zx.theBitMap = bm
        *  zx.theBitmapPosition(40%x,10%y,20%x,20%x)
        *  zx.BeginScan("myzx")
End Sub
        *
        *Sub myzx_result(atype As String,Values As String)
        *  Msgbox(Values,"type:" &  atype)
        *End Sub 
        *
        *Sub myzx_noscan(atype As String,Values As String)
        *  Msgbox(Values,"type:" & atype)
        *End Sub
        </code>
        */
        public void BeginScan(BA ba,String EventName) {

		myba=ba;
		en=EventName.toLowerCase();
		Intent izx;
		izx=new Intent(BA.applicationContext, CaptureActivity.class);
		ion=new IOnActivityResult() {
			
			@Override
			public void ResultArrived(int arg0, Intent arg1) {
                           String atype;
		           String Value;
                           atype = "";
                           Value = ""; 
		           if (arg0==-1){
		             //String atype;               this was moved by johan schoeman (see above) - else the vars are not valid in the "else" statement
		             //String Value;               this was moved by johan schoeman (see above) - else the vars are not valid in the "else" statement 
                             //atype=arg1.getStringExtra("SCAN_RESULT_FORMAT");
			       atype=arg1.getStringExtra("atype");
                             //Value=arg1.getStringExtra("SCAN_RESULT");
			       Value=arg1.getStringExtra("value");
			       myba.raiseEvent2(null, false, en+"_result", true, new Object[]{atype,Value});
			   } else {
                             //this was changed by johan schoeman to return a null scan result if no valid code found within alloted 15 seconds
                               atype = "Null";
                               Value = "Null";
                               myba.raiseEvent2(null, false, en+"_result", true, new Object[]{atype,Value});
			     //Log.i("B4A", "Got other result code:"+arg0);
                                    
			   }
			}
		};
		ba.startActivityForResult(ion, izx);
	}

}


